.ci_triggers: &ci_triggers
  refs:
    - merge_requests
    - develop
    - tags
    - master

.cd_triggers: &cd_triggers
  refs: # Define there branches for which CD must be triggered
    - tags

Build and Test server:
  extends: .nodejs # group-ul/ul-gitlab-ci:nodejs-jobs.yml
  stage: test
  only:
    <<: *ci_triggers
    changes:
      - server/**

  variables:
    DIRECTORY: 'server'
  cache: # TODO: Remove after https://gitlab.com/ratp-usine-digitale/group-ul/ul-gitlab-ci/-/merge_requests/2
    untracked: true
    paths:
      - 'server/node_modules'
  script:
    - 'export VERSION=0.0.1' # Determine version by whatever way
    - '${NODEJS_COMMAND} version --new-version $VERSION --no-git-tag-version'
    - '${NODEJS_COMMAND} run lint'
    - '${NODEJS_COMMAND} run test'
    - '${NODEJS_COMMAND} build'
  artifacts:
    paths:
      - '**/junit.xml'
      - '${DIRECTORY}/package.json' # with version bump
      - '${DIRECTORY}/node_modules'
      - '${DIRECTORY}/build'
    reports:
      junit: '**/junit.xml'
    expire_in: 1 week

Check vulnerabilities server:
  extends: .nodejs_audit # group-ul/ul-gitlab-ci:nodejs-jobs.yml
  stage: build
  variables:
    DIRECTORY: 'server'
  only:
    <<: *cd_triggers
    changes:
      - server/package.json

Build docker server:
  stage: deploy
  only:
    <<: *cd_triggers

  # Rather `extends: .docker_ecr_build` # group-ul/ul-gitlab-ci:docker-jobs.yml
  image: registry.gitlab.com/ratp-usine-digitale/group-ul/docker-images/cicd/deploy:latest
  services:
    - docker:dind

  variables:
    BUILD_DIRECTORY: 'server'
  script:
    - |
      cd ${BUILD_DIRECTORY}
      export VERSION=`grep '"version"' package.json | cut -d '"' -f 4`
    - |
      echo "Version: $VERSION"
      ls build
    - 'docker build -t fastify-backend:VERSION . -f tooling/docker/Dockerfile'
